#include <allegro.h>
#include "level.h"
#include "dlg.h"
#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#define HSND      // pro debugovani zakometovat - nehrajou midi
                  // (ale smaply jo takze je to v podstate na ...)

// par grlobalnich promennych
int errno;

int HSIZE,WSIZE,COLDEPTH;       // vyska obr. sirka obr. bitova hloubka
int CUR_PAGE;                   // stranka, ktera se prave zobrazuje
int CUR_LEVEL= 1;               // level
int BALANCE= 127;               // Jak maji byt vyrovanane leva a prava bednicka
                                // 127 - prostredek, 0 - leva, 255 - prava ...
char LevelFileName[16];         // Soubor, ze ktereho se cte level
char msg[64];                   // zprava, ktera se vypisuje v menu

H3Level hlev;                   // nacteny level ( metoda Load())
H3Frames hf[16];                // Framy na obrazky - tocici se kolecko, podlozi ...
H3Monster hm[MAX_MONSTERS];     // obludy, ktere se vyskytuji (Hroch je vzdy hm[0] a ma ID 0)
RGB pal[256];                   // pomocna promenna (paleta) pro allegro (pouze pro 8-bitove mody a ty moc nepodporuju)
DATAFILE* data;                 // zde jsou ulozeny zvuky a font
char hacka[10];                 // jednotlive klice (0- nema, 1- ma)
BITMAP* cursor;                 // bitmapa pro mysi kurzor
enum {
 NEW_GAME     = 1,              // konstanty co nekdy vraci menu
 SAVE_GAME    = 2,
 LOAD_GAME    = 3,
 BACK_TO_GAME = 4,
 SOUND        = 5,
 END_GAME     = 6,
 MAIN_MENU    = 7,
};

enum {                          // konstanty pro datafile (zvuky, font je 0)
 HROCH_HACKO    = 1,
 HROCH_TELEPORT = 2,
 MENU_OK        = 3,
 MENU_ONM       = 4,
 MENU_QUIT      = 5,
 SNEK_KILL      = 6,
};
/*
#define HROCH_HACKO 1
#define MENU_OK 2
#define MENU_ONM 3
#define MENU_QUIT 4
#define SNEK_KILL 5
  */

void FadeUp(BITMAP* kam);
void FadeDown(BITMAP* kam);

volatile int ticks=0;

void inc_ticks(...)     // timer, to nejhlavnejsi je ZDE
{
 ticks++;
}

END_OF_FUNCTION(inc_ticks);     // ???? - to potrebuje Allegro

void Konec(const char* s)       // proste konec
{
 set_gfx_mode(GFX_TEXT,80,25,0,0);
 unload_datafile(data);
 cout << s;
 remove_int(inc_ticks);
 allegro_exit();
 exit(0);
}

void Uziv_press()       // Ceka na stisk klavesy nebo leveho mysitka
{
 clear_keybuf();
 do {
 } while (!keypressed() && !(mouse_b & 1));
 clear_keybuf();
}

int Paint(int fade)     // hodi udelanou bitmapu na screen
{
 BITMAP* bm= create_bitmap(SCREEN_W,SCREEN_H);
 rectfill(bm,0,0,639,479,makecol(0,0,0));     // vynulujem

 // udelame bitmapu
 hlev.MakeBitmap(CUR_PAGE,bm,hf,hm,hacka,CUR_PAGE,(FONT*) data->dat);
 // ma se fadenout ?
 if (fade) FadeUp(bm);
 // hodi se na obrazovku
 blit(bm,screen,0,0,0,0,SCREEN_W,SCREEN_H);

 destroy_bitmap(bm);
}

int Spadne(char pod1,char pod2) // zisti, jestli spadne
{
 int ok= FALSE;
 if ((pod1<9 && hacka[pod1-1]==1)||(pod1>64 && pod1<113)) ok= TRUE;
 if (((pod2<9 && hacka[pod2-1]==1)||(pod2>64 && pod2<113)) && ok== TRUE) ok= TRUE;
    else ok= FALSE;
 return ok;
}

int VObd(int x1,int y1,int x2,int y2,int x,int y)
{
 if (x1<x && x2>x && y1<y && y2>y) return TRUE;
 return FALSE;
}

// protina se hroch s jinou priserou ?

int Prusecik(int x1,int y1,int x2,int y2,int x3,int y3,int x4,int y4)
{
 if (VObd(x1,y1,x2,y2,x3,y3)) return TRUE;
 if (VObd(x1,y1,x2,y2,x3,y4)) return TRUE;
 if (VObd(x1,y1,x2,y2,x4,y3)) return TRUE;
 if (VObd(x1,y1,x2,y2,x4,y4)) return TRUE;
 return FALSE;
}

int Play(MIDI *mdi)     // fce., ve ktere se odehrava hra
{
#ifdef HSND
 play_midi(NULL,0);
 mdi= load_midi("1.mid");
 play_midi(mdi,TRUE);
#endif

 Paint(TRUE);

 int a= '\0';
 int skok= 0,oldskok= 0;
 int smrt= FALSE;
 int oldmx= mouse_x;
 int oldmy= mouse_y;
 int tel= 0;

 for (;(!key[KEY_ESC] && !(mouse_b & 2)) || (!hm[0].ActionOK());)
  {
   int _x= hm[0].GetX()/10;
   int _y= (hm[0].GetY()-6)/50;

   // ma se prepnout na jinou obrazovku ?
   if (_x<1)
    if (hlev.GetLeft(CUR_PAGE)!= 0)
     {
      CUR_PAGE= hlev.GetLeft(CUR_PAGE)-1;
      hm[0].SetX(510);
      Paint(FALSE);
      continue;
     } else hm[0].SetX(10);
   if (_x>51)
    if (hm[0].GetAction()== SWIM)
     {
      CUR_LEVEL++;
      strcpy(msg,"For next level choose NEW");
      break;
     }
    else if (hlev.GetRight(CUR_PAGE)!= 0)
     {
      CUR_PAGE= hlev.GetRight(CUR_PAGE)-1;
      hm[0].SetX(10);
      Paint(FALSE);
      continue;
     } else hm[0].SetX(520);
   if (_y<0)
    if (hlev.GetUp(CUR_PAGE)!= 0)
     {
      CUR_PAGE= hlev.GetUp(CUR_PAGE)-1;
      hm[0].SetY(346);
      Paint(FALSE);
      continue;
     }
   if (_y>8)
    if (hlev.GetDown(CUR_PAGE)!= 0)
     {
      CUR_PAGE= hlev.GetDown(CUR_PAGE)-1;
      hm[0].SetY(-34);
      Paint(FALSE);
      continue;
     }

   // co je za hrochem ? (hacka,zivoty ...)

   for (int j= hm[0].GetX()/10;j<= 10+hm[0].GetX()/10;j++)
    {
     switch(hlev.GetData(CUR_PAGE,j,(hm[0].GetY()-6)/50))
      {
       case 'z' : if (hm[0].GetLives()<3 && hm[0].GetLives()>0)
            {
             hm[0].SetRelLives(+1);
             hlev.SetData(CUR_PAGE,j,(hm[0].GetY()-6)/50,' ');
             play_sample((SAMPLE*) data[HROCH_HACKO].dat,255,BALANCE,1000,FALSE);
            } break;
      case '0' : case '1' : case '2' : case '3' : case '4' :
      case '5' : case '6' : case '7' : case '8' : case '9' :
           {
            hacka[hlev.GetData(CUR_PAGE,j,(hm[0].GetY()-6)/50)-'0']= 1;
            hlev.SetData(CUR_PAGE,j,(hm[0].GetY()-6)/50,' ');
            play_sample((SAMPLE*) data[HROCH_HACKO].dat,255,BALANCE,1000,FALSE);
           } break;
      // teleporty
      case '<' : if ((key[KEY_ENTER] || mouse_b & 1) && hm[0].ActionOK() && hlev.GetTel1(CUR_PAGE)!= 0)
                  {
                   hm[0].SetAction(TEL_IN);
                   play_sample((SAMPLE*) data[HROCH_TELEPORT].dat,255,BALANCE,1000,FALSE);
                   tel= 1;
                  } break;
      case '>' : if ((key[KEY_ENTER]|| mouse_b & 1) && hm[0].ActionOK() && hlev.GetTel2(CUR_PAGE)!= 0)
                  {
                   hm[0].SetAction(TEL_IN);
                   play_sample((SAMPLE*) data[HROCH_TELEPORT].dat,255,BALANCE,1000,FALSE);
                   tel= 2;
                  } break;
      }
    }

   // teleport ?

   if (hm[0].ActionOK() && hm[0].GetPrevAction()== TEL_IN)
    {
     if (tel== 1) CUR_PAGE= hlev.GetTel1(CUR_PAGE)-1;
     else if (tel== 2) CUR_PAGE= hlev.GetTel2(CUR_PAGE)-1;
     hm[0].SetAction(TEL_OUT);
     Paint(FALSE);
     continue;
    }
   if (hm[0].ActionOK() && hm[0].GetPrevAction()== TEL_OUT)
      hm[0].SetCurBmp(hm[0].GetStEnd(TEL_OUT,ACTION_END));


   char pom[16];
/*   itoa(mouse_x,pom,10);
   textout(screen,font,pom,200,50,makecol(255,255,255));
   itoa(mouse_y,pom,10);
   textout(screen,font,pom,200,70,makecol(255,255,255));//*/

    // co je pod hrochem ? (spadne ?)

    char pod1= hlev.GetData(CUR_PAGE,_x+4,_y+1);
    char pod2= hlev.GetData(CUR_PAGE,_x+7,_y+1);
    int ok= Spadne(pod1,pod2);
    if (!ok) {
    if (hm[0].ActionOK())
    {
     hm[0].SetAction(JUMP_DOWN);
     skok++;
     oldskok= skok;
     } } else skok= 0;

   if (pod1== 'B' && pod2== 'B') if (hm[0].GetAction()!= SWIM) hm[0].SetAction(SWIM);

   // jstlize spadl, o kolik ?

   if (skok==0 && oldskok== 2)
    { hm[0].SetRelLives(-1); oldskok=0; }
   else if (skok==0 && oldskok>2)
    { hm[0].SetLives(0); oldskok=0; }

   if (hm[0].GetY()>406 && hlev.GetDown(CUR_PAGE)== 0 && hm[0].GetAction()!= DEATH_1)
    {
      hm[0].SetLives(0);
      hm[0].SetAction(NO_ACTION);
    }

   // ma zivoty na 0 ?

   if (hm[0].GetLives()== 0 && hm[0].ActionOK() && smrt== TRUE)
    {
     clear_keybuf();
     Uziv_press();
     break;
    }
   if (hm[0].GetLives()== 0) if (hm[0].ActionOK())
    {
     hm[0].SetAction(DEATH_1);
     smrt= TRUE;
    }

   // akce hrocha

   if (key[KEY_UP] || oldmy-1>mouse_y) if (hm[0].ActionOK() && _y>0) hm[0].SetAction(JUMP_UP);
                     else if (hm[0].ActionOK() && _y<1 && hlev.GetUp(CUR_PAGE)!=0) hm[0].SetAction(JUMP_UP);
   if (key[KEY_RIGHT] || oldmx+1<mouse_x) if (hm[0].ActionOK()) hm[0].SetAction(STEP_RIGHT);
                       else if ((hm[0].GetAction()== JUMP_UP ||
                                hm[0].GetAction()== JUMP_DOWN) &&
                                hm[0].ActionPlusOK()) hm[0].SetActionPlus(STEP_RIGHT);
   if (key[KEY_LEFT] || oldmx-1>mouse_x) if (hm[0].ActionOK()) hm[0].SetAction(STEP_LEFT);
                      else if ((hm[0].GetAction()== JUMP_UP ||
                               hm[0].GetAction()== JUMP_DOWN) &&
                               hm[0].ActionPlusOK()) hm[0].SetActionPlus(STEP_LEFT);

   // akce monstra

   for (int i= 1;i<MAX_MONSTERS;i++)
     if (hm[i].GetID()!= -1 && hm[i].GetLives()>0 && hm[i].GetPage()== CUR_PAGE)
      {
       if (hm[i].GetType()== TYPE_SNEK)
        {
         if (Prusecik(hm[0].GetX()+10,hm[0].GetY(),hm[0].GetX()+hm[0].GetW()-10,hm[0].GetY()+hm[0].GetH(),
            hm[i].GetX(),hm[i].GetY(),hm[i].GetX()+hm[i].GetW(),hm[i].GetY()+hm[i].GetH()) && hm[i].ActionOK())
          {
           hm[0].SetRelLives(-1);
           hm[i].SetRelLives(-1);
          }

         char pod1= hlev.GetData(CUR_PAGE,hm[i].GetX()/10,(hm[i].GetY()-31)/50+1);
         char pod2= hlev.GetData(CUR_PAGE,hm[i].GetX()/10+5,(hm[i].GetY()-31)/50+1);
         if (hm[i].ActionOK())
          if (hm[i].GetX()<5) hm[i].SetAction(STEP_RIGHT);
          else if (hm[i].GetX()>635) hm[i].SetAction(STEP_LEFT);
          else if (Spadne(pod1,pod2)== FALSE)
           { if (hm[i].GetPrevAction()== STEP_LEFT) hm[i].SetAction(STEP_RIGHT);
             else if (hm[i].GetPrevAction()== STEP_RIGHT) hm[i].SetAction(STEP_LEFT);
           }
          else if (hm[i].GetPrevAction()== NO_ACTION) hm[i].SetAction(STEP_LEFT);
          else hm[i].SetAction(hm[i].GetPrevAction());
        }
      } else if (hm[i].GetID()!= -1 && hm[i].GetLives()<=0 && hm[i].GetAction()!= DEATH_1 && hm[i].GetPage()== CUR_PAGE)
      {
       if (hm[i].GetPrevAction()!= DEATH_1)
        {
         hm[i].SetAction(DEATH_1);
         play_sample((SAMPLE*) data[SNEK_KILL].dat,255,BALANCE,1000,FALSE);
        }
       else hm[i].SetCurBmp(20);
      }


   // ma se malovat ?

   if (ticks> 0)
    {
     position_mouse(WSIZE/2,HSIZE/2);
     oldmx= mouse_x;
     oldmy= mouse_y;
     ticks= 0;
     Paint(FALSE);
    }
  }
 BITMAP *bm= create_bitmap(WSIZE,HSIZE);
 blit(screen,bm,0,0,0,0,WSIZE,HSIZE);
 FadeDown(bm);
 destroy_bitmap(bm);
}

void Init(MIDI *mdi)    // inicializace a vypsani tech blbosti na zacatku
{
 strcpy(LevelFileName,"levels.dat");

 cout << "Allegro init: ";
 if (allegro_init()) Konec("Failed.\n");
    else cout << "OK\n";
 cout << "Timer install: ";
 if (install_timer()) Konec("Failed.\n");
    else cout << "OK\n";
 cout << "Keyboard install: ";
 if (install_keyboard()) Konec("Failed.\n");
    else cout << "OK\n";
 cout << "Mouse install: ";
 if (install_mouse()== -1) cout << "Failed.\nDon't worry !\n";
    else cout << "OK\n";

 cout << "Checking OS: ";
 switch (os_type)
 {
  case OSTYPE_UNKNOWN : cout << "OK(MS-DOS)\n"; break;
  case OSTYPE_WIN3 : cout << "OK(WIN 3.x)\n"; break;
  case OSTYPE_WIN95 : cout << "OK(WIN 9x)\nHOW CAN YOU USE IT?\n"; break;
  case OSTYPE_WINNT : cout << "WINNT\nHere may be some problems ! (Run it on other OS)\n"; break;
  case OSTYPE_DOSEMU : cout << "OK(Linux DOSEMU)\nGreat stuff.n"; break;
  case OSTYPE_OPENDOS : cout << "OK(Caldera OpenDOS)\n"; break;
  case OSTYPE_OS2 : cout << "OK(OS/2)\n"; break;
  case OSTYPE_WARP : cout << "OK(OS/2 Warp 3)\n"; break;
  default : cout << "Failed. (OS unknown)\n";
 }

 cout << "Checking CPU: ";
 check_cpu();
 switch (cpu_family)
 {
  case 3 : cout << "OK(386)\nYou must be brave !\n"; break;
  case 4 : cout << "OK(486)\n"; break;
  case 5 : cout << "OK(Pentium)\n"; break;
  case 6 : cout << "OK(Pentium Pro)\n"; break;
  case 7 : cout << "OK(Some great machine)\n"; break;
  default : cout << "Failed. (CPU unknown)\n";
 }

#ifdef HSND
 cout << "Sound install: ";
 if (install_sound(DIGI_AUTODETECT,MIDI_AUTODETECT,NULL))
    cout << "Failed.\n";
    else cout << "OK\n";
#endif
 cout << "Loading datafile: " << flush;
 data= load_datafile("hippo3.dat");
 if (!data) Konec("Failed.\n");
 else if (data->type!= DAT_FONT) Konec("Failed.\nDatafile doesn't contain font.\n");
 else cout << "OK\n";

// cout << "Setting GFX mode...";

 ifstream is;

 HSIZE= 480;
 WSIZE= 640;
 COLDEPTH= 24;
 cout << "Loading inifile: ";
 is.open("hippo3.ini");
 if (is.bad() || is.fail()) cout << "Failed.\nUsing defaults.\n";
 else
  {
   is >> WSIZE;
   if (is.fail())
    {
     cout << "Failed.\nUsing defaults.\n";
     WSIZE= 460;
    } else
    {
     is >> HSIZE;
     if (is.fail())
      {
       cout << "Failed.\nUsing defaults.\n";
       WSIZE= 460; WSIZE= 480;
      } else
      {
       is >> COLDEPTH;
       if (is.fail())
        {
         cout << "Failed.\nUsing defaults.\n";
         WSIZE= 460; WSIZE= 480; COLDEPTH= 24;
        } else
        {
         is >> Samplevol;
         if (is.fail()) Samplevol= 255;
         is >> MIDIvol;
         if (is.fail()) MIDIvol= 255;
         is >> LevelFileName;
         if (is.fail()) strcpy(LevelFileName,"levels.dat");
         is >> CUR_LEVEL;
         if (is.fail()) CUR_LEVEL= 1;
         cout << "OK\nUsing levelfile: " << LevelFileName << endl;
        }
      }
    }
  }
 cout << "Setting color depth: ";
 set_color_depth(COLDEPTH); // musi se nastavit pred loadovanim bitmap, jinak cte 8 bitu
 cout << COLDEPTH << endl;
 cout << "Loading bitmaps: " << flush;

// nacteni obrazku

 // udava, kde zacinaji obrazky k akcim hrocha
 char stend[15][2];
 stend[STEP_RIGHT][0]=0;
 stend[STEP_RIGHT][1]=4;
 stend[STEP_LEFT][0]=4;
 stend[STEP_LEFT][1]=8;
 stend[JUMP_UP][0]=8;
 stend[JUMP_UP][1]=12;
 stend[JUMP_DOWN][0]=12;
 stend[JUMP_DOWN][1]=16;
 stend[DEATH_1][0]=16;
 stend[DEATH_1][1]=21;
 stend[TEL_IN][0]=21;
 stend[TEL_IN][1]=27;
 stend[TEL_OUT][0]=26;
 stend[TEL_OUT][1]=31;
 stend[SWIM][0]=32;
 stend[SWIM][1]=34;


 if (hf[0].Load(0,10,20,1,"podlozi.pcx",pal)) cout << "." << flush;
    else cout << "Failed. (podlozi.pcx)\n" << flush;
 if (hf[1].Load(2,10,20,22,"podlozi.pcx",pal)) cout << "." << flush;
    else cout << "Failed. (podlozi.pcx)\n" << flush;
 if (hf[2].Load(3,32,80,43,"podlozi.pcx",pal)) cout << "." << flush;
    else cout << "Failed. (podlozi.pcx)\n" << flush;
 if (hf[3].Load(7,10,12,125,"podlozi.pcx",pal)) cout << "." << flush; // srdicko
    else cout << "Failed. (podlozi.pcx)\n" << flush;
 if (hf[4].Load(7,10,12,139,"podlozi.pcx",pal)) cout << "." << flush; // kolecko
    else cout << "Failed. (podlozi.pcx)\n" << flush;
 if (hf[5].Load(4,16,36,153,"podlozi.pcx",pal)) cout << "." << flush; // pochoden
    else cout << "Failed. (podlozi.pcx)\n" << flush;
 if (hf[6].Load(2,33,48,191,"podlozi.pcx",pal)) cout << "." << flush; // teleport
    else cout << "Failed. (podlozi.pcx)\n" << flush;
 if (hf[7].Load(6,10,20,241,"podlozi.pcx",pal)) cout << "." << flush; // podlozi 2
    else cout << "Failed. (podlozi.pcx)\n" << flush;
 if (hf[8].Load(0,10,20,262,"podlozi.pcx",pal)) cout << "." << flush; // podlozi 3
    else cout << "Failed. (podlozi.pcx)\n" << flush;
 if (hf[9].Load(0,10,20,283,"podlozi.pcx",pal)) cout << "." << flush; // podlozi 4
    else cout << "Failed. (podlozi.pcx)\n" << flush;
 if (hf[10].Load(0,10,20,304,"podlozi.pcx",pal)) cout << "." << flush; // podlozi 4
    else cout << "Failed. (podlozi.pcx)\n" << flush;
 if (hm[0].Load(33,113,54,1,"hroch.pcx",pal)) cout << "." << flush;  // hroch
    else cout << "Failed. (hroch.pcx)\n" << flush;
 hm[0].SetStEnd(stend);
 hm[0].SetLives(3);

 cursor= load_bitmap("kurzor.pcx",pal);
 if (cursor) cout << "." << flush;
    else cout << "Failed. (kurzor.pcx)\n" << flush;
 cout << " Done.\n";

 cout << "Hit key to play(?) the best(?) game in the world !\n";
 Uziv_press();
 if (set_gfx_mode(GFX_AUTODETECT,WSIZE,HSIZE,0,0))
  {
   Konec("Can't set required GFX mode.\n");
  }

// hm[0].Load(31,113,54,1,"hroch.pcx",pal);
// hm[0].SetStEnd(stend);
// hm[0].SetLives(3);


 if (COLDEPTH== 8) set_palette(pal);
 set_mouse_sprite(cursor);
 set_mouse_sprite_focus(0,0);
 LOCK_VARIABLE(ticks);
 LOCK_FUNCTION(inc_ticks);
 install_int(inc_ticks,50);
 text_mode(-1);
 set_volume(Samplevol,MIDIvol);
 SOUND_DLG[5].d2= MIDIvol;
 SOUND_DLG[6].d2= Samplevol;
}

void Popis(BITMAP *bm)
{
 textout(bm,(FONT*) data->dat,"New",140,115,makecol(0,250,0));
 textout(bm,(FONT*) data->dat,"Save",340,115,makecol(0,230,0));
 textout(bm,(FONT*) data->dat,"Load",540,115,makecol(0,210,0));
 textout(bm,(FONT*) data->dat,"Back",140,315,makecol(0,190,0));
 textout(bm,(FONT*) data->dat,"Sound",340,315,makecol(0,170,0));
 textout(bm,(FONT*) data->dat,"Quit",540,315,makecol(0,150,0));
}

// nacte hru

int LoadGame()
{
 FILE* fil;
 play_sample((SAMPLE*) data[MENU_OK].dat,255,BALANCE,1000,FALSE);
 show_mouse(NULL);
 if (do_dialog(LOAD_SAVE_DLG,-1)== 2)   // Allegro gui dialog (v dlg.h)
  {
   play_sample((SAMPLE*) data[MENU_OK].dat,255,BALANCE,1000,FALSE);
   fil= fopen((char*) LOAD_SAVE_DLG[6].dp,"rb");
   if (!fil)
    {
     do_message_box("          Error:","    Can''t open file !");
     return FALSE;
    }
   else
    {
     // level
     unsigned char tmp;
     fread(&CUR_LEVEL,4,1,fil);
     fread(&CUR_PAGE,4,1,fil);
     fread(&tmp,1,1,fil);
     hlev.SetLevNum(tmp);
     fread(&tmp,1,1,fil);
     hlev.SetPages(tmp);
     for (int i= 0;i<=hlev.GetPages();i++)
      {
       int pom= fread(&tmp,1,1,fil); // cislo stranky
       if (i!= tmp)
        {
         char zpr[255];
         sprintf(zpr,"%i != %i (%i)",i,tmp,pom);
         do_message_box("          Error:",zpr);
//         fclose(fil);
//         return FALSE;
        }
// unsigned char left,right,up,down,tel1,tel2,bckgrd;
       fread(&tmp,1,1,fil); hlev.SetLeft(i,tmp);
       fread(&tmp,1,1,fil); hlev.SetRight(i,tmp);
       fread(&tmp,1,1,fil); hlev.SetUp(i,tmp);
       fread(&tmp,1,1,fil); hlev.SetDown(i,tmp);
       fread(&tmp,1,1,fil); hlev.SetTel1(i,tmp);
       fread(&tmp,1,1,fil); hlev.SetTel2(i,tmp);
       fread(&tmp,1,1,fil); hlev.SetBackground(i,tmp);
       for (int _y=0;_y< 10;_y++)
        for (int _x=0;_x<=64;_x++)
         {
          if (fread(&tmp,1,1,fil)!= 1)
           {
            char zpr[255];
            sprintf(zpr,"%i , %i (%i , %i , %i)",_x,_y,tmp,ftell(fil),i);
            do_message_box("          Error:",zpr);
            fclose(fil);
            return FALSE;
           }
          hlev.SetData(i,_x,_y,tmp);
         }
      }
     // monsters
     for (int i= 0;i< MAX_MONSTERS;i++)
     {
// int x,y,ID,lives,type,page,he,wi,prevac;
      int tmp2;
      fread(&tmp2,4,1,fil); hm[i].SetID(tmp2);
      fread(&tmp2,4,1,fil); hm[i].SetX(tmp2);
//      char s[16];
//      do_message_box("    Debug message:",itoa(tmp2,s,10));
      fread(&tmp2,4,1,fil); hm[i].SetY(tmp2);
      fread(&tmp2,4,1,fil); hm[i].SetLives(tmp2);
      fread(&tmp2,4,1,fil); hm[i].SetType(tmp2);
      fread(&tmp2,4,1,fil); hm[i].SetPage(tmp2);
      fread(&tmp2,4,1,fil); hm[i].SetH(tmp2);
      fread(&tmp2,4,1,fil); hm[i].SetW(tmp2);
      fread(&tmp2,4,1,fil); hm[i].SetPrevAction(tmp2);
     }
     // hacka
     if (fread(hacka,1,10,fil)!= 10)
      {
       do_message_box("          Error:","          Read error !");
       fclose(fil);
       return FALSE;
      }
    }
   fclose(fil);
  } else play_sample((SAMPLE*) data[MENU_QUIT].dat,255,BALANCE,1000,FALSE);
 ticks= 0;
 clear_keybuf();
 text_mode(-1);

 return TRUE;
}

// co asi dela tohle ?

void SaveGame()
{
 FILE* fil;
 play_sample((SAMPLE*) data[MENU_OK].dat,255,BALANCE,1000,FALSE);
 show_mouse(NULL);
 if (do_dialog(LOAD_SAVE_DLG,-1)== 2)
  {
   play_sample((SAMPLE*) data[MENU_OK].dat,255,BALANCE,1000,FALSE);
   fil= fopen((char*) LOAD_SAVE_DLG[6].dp,"wb");
//   fil= fopen((char*) LOAD_SAVE_DLG[6].dp,"r");
   if (!fil) do_message_box("          Error:","    Can''t open file !");
   else
    {
     // level
     fwrite(&CUR_LEVEL,4,1,fil);
     fwrite(&CUR_PAGE,4,1,fil);
     unsigned char tmp= hlev.GetLevNum();
     fwrite(&tmp,1,1,fil);
     tmp= hlev.GetPages();
     fwrite(&tmp,1,1,fil);
     for (unsigned char i= 0;i<=hlev.GetPages();i++)
      {
       fwrite(&i,1,1,fil);
// unsigned char left,right,up,down,tel1,tel2,bckgrd;
       tmp= hlev.GetLeft(i); fwrite(&tmp,1,1,fil);
       tmp= hlev.GetRight(i); fwrite(&tmp,1,1,fil);
       tmp= hlev.GetUp(i); fwrite(&tmp,1,1,fil);
       tmp= hlev.GetDown(i); fwrite(&tmp,1,1,fil);
       tmp= hlev.GetTel1(i); fwrite(&tmp,1,1,fil);
       tmp= hlev.GetTel2(i); fwrite(&tmp,1,1,fil);
       tmp= hlev.GetBackground(i); fwrite(&tmp,1,1,fil);

       for (int _y=0;_y< 10;_y++)
        for (int _x=0;_x<=64;_x++)
         {
          tmp= hlev.GetData(i,_x,_y);
          if (fwrite(&tmp,1,1,fil)!= 1)
           {
            do_message_box("          Error:","  Can't write to file !");
            fclose(fil);
            return;
           }
         }
      }
     // monsters
     for (int i= 0;i< MAX_MONSTERS;i++)
     {
// int x,y,ID,lives,type,page,he,wi,prevac;
      int tmp2;
      tmp2= hm[i].GetID(); fwrite(&tmp2,4,1,fil);
      tmp2= hm[i].GetX(); fwrite(&tmp2,4,1,fil);
      tmp2= hm[i].GetY(); fwrite(&tmp2,4,1,fil);
      tmp2= hm[i].GetLives(); fwrite(&tmp2,4,1,fil);
      tmp2= hm[i].GetType(); fwrite(&tmp2,4,1,fil);
      tmp2= hm[i].GetPage(); fwrite(&tmp2,4,1,fil);
      tmp2= hm[i].GetH(); fwrite(&tmp2,4,1,fil);
      tmp2= hm[i].GetW(); fwrite(&tmp2,4,1,fil);
      tmp2= hm[i].GetPrevAction(); fwrite(&tmp2,4,1,fil);
     }
     // hacka
     if (fwrite(hacka,1,10,fil)!= 10)
      {
       do_message_box("          Error:","         Write error !");
       fclose(fil);
       return;
      }
    }
   fclose(fil);
  } else play_sample((SAMPLE*) data[MENU_QUIT].dat,255,BALANCE,1000,FALSE);
 ticks= 0;
 clear_keybuf();
 text_mode(-1);
}

// stvori menu

int Menu(MIDI* mdi,const char* message)
{
#ifdef HSND
 mdi= load_midi("2.mid");
 play_midi(mdi,TRUE);
#endif
 clear_keybuf();

 int oldhx= hm[0].GetX();
 int retval= NEW_GAME;
 BITMAP *bm= create_bitmap(SCREEN_W,SCREEN_H);
 BITMAP *pom= create_bitmap(SCREEN_W,SCREEN_H);
 BITMAP *obrazek= load_bitmap("hippo.pcx",pal);
 BITMAP *zaklh= create_bitmap(113,53);
 BITMAP *pom2= create_bitmap(113,53);
 RGB pal[256];

 rectfill(bm,0,0,bm->w,bm->h,makecol(0,0,0));
 rectfill(pom,0,0,pom->w,pom->h,makecol(0,64,0));
 blit(obrazek,bm,0,0,0,130,640,210);

 hm[0].SetAction(STEP_RIGHT);
 hm[0].GetThis(pom);
 masked_blit(pom,bm,0,0,100,100,113,53);
 masked_blit(pom,bm,0,0,300,100,113,53);
 masked_blit(pom,bm,0,0,500,100,113,53);
 masked_blit(pom,bm,0,0,100,300,113,53);
 masked_blit(pom,bm,0,0,300,300,113,53);
 masked_blit(pom,bm,0,0,500,300,113,53);

 blit(pom,zaklh,0,0,0,0,zaklh->w,zaklh->h);
 Popis(bm);
 show_mouse(bm);
 FadeUp(bm);
 blit(bm,screen,0,0,0,0,SCREEN_W,SCREEN_H);
 rectfill(bm,0,0,bm->w,bm->h,makecol(0,0,0));

 char a;
 int kde= 0,oldkde=0;
 ticks= 0;

 for (;;)
  {
   if (key[KEY_ESC])
    {
     retval= BACK_TO_GAME;
     break;
    }
   if (key[KEY_F1])
    {
     retval= NEW_GAME;
     break;
    }
   if (key[KEY_F2] || (mouse_b & 1 && kde== 2))
    {
     hm[0].SetX(oldhx);
     SaveGame();
    }
   if (key[KEY_F3] || (mouse_b & 1 && kde== 3))
    {
     retval= LOAD_GAME;
     break;
    }
   if (key[KEY_F5] || (mouse_b & 1 && kde== 5))
    {
     play_sample((SAMPLE*) data[MENU_OK].dat,255,BALANCE,1000,FALSE);
     show_mouse(NULL);
     smp= (SAMPLE*) data[MENU_ONM].dat;
     SOUND_DLG[5].d2= MIDIvol;
     SOUND_DLG[6].d2= Samplevol;
     if (do_dialog(SOUND_DLG,-1)== 1)
      {
       MIDIvol= SOUND_DLG[5].d2;
       Samplevol= SOUND_DLG[6].d2;
       set_volume(Samplevol,MIDIvol);
       play_sample((SAMPLE*) data[MENU_OK].dat,255,BALANCE,1000,FALSE);
      } else
      {
       set_volume(Samplevol,MIDIvol);
       play_sample((SAMPLE*) data[MENU_QUIT].dat,255,BALANCE,1000,FALSE);
      }
     ticks= 0;
     clear_keybuf();
     text_mode(-1);
    }
   if (key[KEY_F6])
    {
     retval= END_GAME;
     break;
    }
   if (mouse_b & 1 && (kde== 1 || kde== 6 || kde== 4))
    {
     retval= kde;
     break;
    }
   if (ticks>0)
    {
     if (mouse_x>100 && mouse_x<213 && mouse_y>100 && mouse_y<153) kde= 1;
     else if (mouse_x>300 && mouse_x<413 && mouse_y>100 && mouse_y<153) kde= 2;
     else if (mouse_x>500 && mouse_x<613 && mouse_y>100 && mouse_y<153) kde= 3;
     else if (mouse_x>100 && mouse_x<213 && mouse_y>300 && mouse_y<353) kde= 4;
     else if (mouse_x>300 && mouse_x<413 && mouse_y>300 && mouse_y<353) kde= 5;
     else if (mouse_x>500 && mouse_x<613 && mouse_y>300 && mouse_y<353) kde= 6;
     else kde= 0;
  
     if (kde!=oldkde)
      {
       hm[0].SetAction(STEP_RIGHT);
       if (kde!= 0) play_sample((SAMPLE*) data[MENU_ONM].dat,255,BALANCE,1000,FALSE);
      }
        else if (hm[0].ActionOK())
         {
          hm[0].SetAction(STEP_RIGHT);
//          if (kde!= 0) play_sample((SAMPLE*) data[MENU_ONM].dat,255,BALANCE,1000,FALSE);
         }
     // tady se dela bimapa

     hm[0].GetNext(pom);
     blit(obrazek,bm,0,0,0,130,640,210);
     for (int i=1;i<=6;i++)
     {
      int cd;
      if (oldkde==kde) cd= kde; else cd= oldkde;
      if (cd== i) blit(pom,pom2,0,0,0,0,113,53);
      else blit(zaklh,pom2,0,0,0,0,113,53);
      switch (i)
      {
      case 1 : masked_blit(pom2,bm,0,0,100,100,113,53); break;
      case 2 : masked_blit(pom2,bm,0,0,300,100,113,53); break;
      case 3 : masked_blit(pom2,bm,0,0,500,100,113,53); break;
      case 4 : masked_blit(pom2,bm,0,0,100,300,113,53); break;
      case 5 : masked_blit(pom2,bm,0,0,300,300,113,53); break;
      case 6 : masked_blit(pom2,bm,0,0,500,300,113,53); break;
      }
     }
     Popis(bm);
     if (*message) textout(bm,(FONT*) data->dat,(char*) message,230,50,makecol(255,0,0));
     if (ticks>1) textout(bm,(FONT*) data->dat,"YOU HAVE SLOW VIDEO CARD !",230,400,makecol(255,0,0));
     show_mouse(bm);
//     a tady se mrdne na obrazovku
     blit(bm,screen,0,0,0,0,SCREEN_W,SCREEN_H);
     show_mouse(NULL);
     rectfill(bm,0,0,bm->w,bm->h,makecol(0,0,0));

     oldkde= kde;
     ticks= 0;
    }
  }
 if (retval!= END_GAME) play_sample((SAMPLE*) data[MENU_OK].dat,255,BALANCE,1000,FALSE);
    else play_sample((SAMPLE*) data[MENU_QUIT].dat,255,BALANCE,1000,FALSE);


 // neco jsme si vybrali
 clear_keybuf();
 destroy_bitmap(bm);
 destroy_bitmap(pom);
 hm[0].SetAction(NO_ACTION);
 show_mouse(NULL);
 switch (retval)
 {
  case BACK_TO_GAME : hm[0].SetX(oldhx); break;
  case NEW_GAME :
  case LOAD_GAME : {
                  if (retval== NEW_GAME)
                   {
                    for (int i= 1;i<MAX_MONSTERS;i++) hm[i].SetID(-1);
                    if (hlev.Load(CUR_LEVEL,hm,LevelFileName)) Konec("Can't load level !\n");
                    CUR_PAGE= 0;
//                  CUR_LEVEL= 1;
                    hm[0].SetLives(3);
                    for (int i= 0;i<10;i++) hacka[i]= 0;
                   } else if (!LoadGame()) return MAIN_MENU;
                  for (int i= 1;i<MAX_MONSTERS;i++)
                   {
                    if (hm[i].GetID()!= -1)
                     {
                      char stend[13][2];
                      switch (hm[i].GetType())
                       {
                        case TYPE_SNEK :
                         {
                          hm[i].Load(20,48,28,1,"snek.pcx",pal);
                          stend[STEP_RIGHT][0]=0;
                          stend[STEP_RIGHT][1]=6;
                          stend[STEP_LEFT][0]=6;
                          stend[STEP_LEFT][1]=12;
                          stend[DEATH_1][0]=12;
                          stend[DEATH_1][1]=21;
                          hm[i].SetStEnd(stend);
                          if (retval== NEW_GAME) hm[i].SetLives(1);
                          hm[i].SetAction(NO_ACTION);
                          hm[i].SetPrevAction(NO_ACTION);
                         } break;
                       }
                    }
                    }
                  } break;
 }

 destroy_bitmap(pom);
 destroy_bitmap(obrazek);
 destroy_bitmap(zaklh);
 destroy_bitmap(pom2);

 blit(screen,bm,0,0,0,0,WSIZE,HSIZE);
 FadeDown(bm);
 destroy_bitmap(bm);

 return retval;
}

// no comment

void FadeUp(BITMAP* bmp)
{
   BITMAP *buffer;
   PALLETE pal;
   int alpha;

   buffer = create_bitmap(SCREEN_W, SCREEN_H);
   rectfill(buffer,0,0,SCREEN_W,SCREEN_H,makecol(0,0,0));

   get_pallete(pal);

   for (alpha=64; alpha<128; alpha+=8) {
      set_trans_blender(0,0,0,alpha);
      draw_trans_sprite(buffer,bmp,0,0);
      vsync();
      blit(buffer,screen,0,0,0,0,WSIZE,HSIZE);
   }

   blit(bmp,screen,0,0,0,0,WSIZE,HSIZE);
   destroy_bitmap(buffer);
}

void FadeDown(BITMAP* bmp)
{
   BITMAP *buffer;
   PALLETE pal;
   int alpha;

   buffer = create_bitmap(SCREEN_W, SCREEN_H);
   blit(bmp,buffer,0,0,0,0,WSIZE,HSIZE);
   rectfill(bmp,0,0,SCREEN_W,SCREEN_H,makecol(0,0,0));

   get_pallete(pal);

   for (alpha=80; alpha<128; alpha+=8) {
      set_trans_blender(0, 0, 0, alpha);
      draw_trans_sprite(buffer,bmp,0,0);
      vsync();
      blit(buffer,screen,0,0,0,0,SCREEN_W, SCREEN_H);
   }

   blit(bmp,screen,0,0,0,0,0,0);
   destroy_bitmap(buffer);
}

int main()
{
 MIDI *mdi= new MIDI;

 Init(mdi);
 for (int rv;rv= Menu(mdi,msg);)
  {
   if (rv== END_GAME) break;
   if (rv== MAIN_MENU) continue;
   msg[0]= '\0';
   Play(mdi);
  }

#ifdef HSND
 play_midi(NULL,0);
 delete mdi;
#endif

 Konec("\nBye.\n");
 return 0;
}
